----------------------------------------------------------------------------------
-- COPYRIGHT 2015 Jess Eduardo Mndez Rosales
--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
--
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
--
--							RS232 CON LCD
--
-- Descripcin: En ste proyecto se utilizaron las librerias RS232 y LCD para que trabajen en conjunto
--					 y demostrar que pueden ser utilizadas para aplicaciones prcticas
--
--
-- Objetivo: Mandar a escribir en la LCD el texto que nosotros escribamos con el teclado.
--
-- Consideraciones: Se debe utilizar un programa externo para mandar los datos ya sea JAVA, labview, Hrcules, etc..
--
--				


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


entity TOP is

PORT(CLK: IN STD_LOGIC;

-------------------------------------------------------
-------------PUERTOS DE LA LCD (NO BORRAR)-------------
	  RS : OUT STD_LOGIC;									  --
	  RW : OUT STD_LOGIC;									  --
	  ENA : OUT STD_LOGIC;									  --
	  CORD : IN STD_LOGIC;									  --
	  CORI : IN STD_LOGIC;									  --
	  DATA_LCD: OUT STD_LOGIC_VECTOR(7 DOWNTO 0); --;  --
-------------------------------------------------------

			RX :			in std_logic ;
			TX_INI :		in std_logic ;
			TX_FIN :		out std_logic ;
			TX :			out std_logic ;
			
			DATAIN :		in std_logic_vector(7 downto 0);
			DOUT2 :		out std_logic_vector(7 downto 0)
	
	  );


end TOP;

architecture Behavioral of TOP is


SIGNAL I,K,J : INTEGER RANGE 1 TO 50 := 1;
SIGNAL D : STD_LOGIC := '0';

SIGNAL FIG1 : INTEGER RANGE 0 TO 8 := 5;--5,7,8

SIGNAL RX_IN_S : STD_LOGIC;
SIGNAL DOUT_S,DOUT_S2,BLCD : STD_LOGIC_VECTOR(7 DOWNTO 0);

SIGNAL ESTADO : INTEGER RANGE 0 TO 5 := 0;


COMPONENT LIB_LCD_INTESC_REVB is

PORT(CLK: IN STD_LOGIC;

-------------------------------------------------------
-------------PUERTOS DE LA LCD (NO BORRAR)-------------
	  RS : OUT STD_LOGIC;									  --
	  RW : OUT STD_LOGIC;									  --
	  ENA : OUT STD_LOGIC;									  --
	  CORD : IN STD_LOGIC;									  --
	  CORI : IN STD_LOGIC;									  --
	  DATA_LCD: OUT STD_LOGIC_VECTOR(7 DOWNTO 0); --; --
	  BLCD :  OUT STD_LOGIC_VECTOR(7 DOWNTO 0);       --
-------------------------------------------------------
	  
-----------------------------------------------------------
--------------ABAJO ESCRIBE TUS PUERTOS--------------------
	 I,J : IN INTEGER;
	 DOUT_S2 : IN STD_LOGIC_VECTOR
	
	
-----------------------------------------------------------
	  );

end COMPONENT LIB_LCD_INTESC_REVB;



COMPONENT RS232 is

port	(	CLK : 		in std_logic ;
			RX :			in std_logic ;
			TX_INI :		in std_logic ;
			TX_FIN :		out std_logic ;
			TX :			out std_logic ;
			RX_IN :		out std_logic ;
			DATAIN :		in std_logic_vector(7 downto 0);
			DOUT :		out std_logic_vector(7 downto 0)
		);
end COMPONENT RS232;


begin

LIB_RS232 : RS232 PORT MAP	(	CLK => CLK,
								RX  => RX,
								TX_INI => TX_INI,
								TX_FIN => TX_FIN,
								TX => TX,
								RX_IN => RX_IN_S,
								DATAIN => DATAIN,
								DOUT => DOUT_S
							);



LIB_LCD :LIB_LCD_INTESC_REVB PORT MAP(CLK => CLK,
		RS => RS,
	  RW => RW,
	  ENA => ENA,
	  CORD => CORD,
	  CORI => CORI,
	  DATA_LCD => DATA_LCD,
	 I => I,
	 J => J,
	 BLCD => BLCD,
	 DOUT_S2 => DOUT_S2
	  );


DOUT2 <= DOUT_S2;	
			

PROCESS(CLK)
BEGIN
	IF RISING_EDGE(CLK) THEN
		
		CASE ESTADO IS
		
			WHEN 0 =>
					IF RX_IN_S = '1' THEN
						ESTADO <= 1;
					ELSE
						ESTADO <= 0;
					END IF;
										
			WHEN 1 =>		
				
				IF BLCD = x"05" THEN
					DOUT_S2 <= x"00";
					ESTADO <= 0;			
					I <= I+1;
						IF I = 16 THEN
							I <= 1;
							J <= J+1;
							IF J = 2 THEN
								J <= 1;
							END IF;
						END IF;
						
				ELSE
					ESTADO <= 1;
					DOUT_S2 <= DOUT_S;
				END IF;
					
			WHEN OTHERS => NULL;
			
		END CASE;
		
	END IF;
END PROCESS;



end Behavioral;

